module "vpc_details" {
  source       = "git::https://gitlab.com/terraswifft/platform/starter/vpc_details.git?ref=main"
  for_each     = var.rds_aurora_config
  vpc_id       = try(each.value.vpc_id, var.vpc_id)
  vpc_name     = try(each.value.vpc_name, var.vpc_name)
  subnet_ids   = try(each.value.subnet_ids, var.subnet_ids)
  subnet_names = try(each.value.subnet_names, var.subnet_names)
}
module "rds-aurora" {
  source                                      = "terraform-aws-modules/rds-aurora/aws"
  version                                     = "8.3.1"
  for_each                                    = var.rds_aurora_config
  name                                        = try(each.value.name, each.key, var.name)
  tags                                        = try(each.value.tags, var.tags)
  create_db_subnet_group                      = try(each.value.create_db_subnet_group, var.create_db_subnet_group)
  db_subnet_group_name                        = try(each.value.db_subnet_group_name, var.db_subnet_group_name)
  subnets                                     = module.vpc_details[each.key].subnet_ids
  is_primary_cluster                          = try(each.value.is_primary_cluster, var.is_primary_cluster)
  cluster_use_name_prefix                     = try(each.value.cluster_use_name_prefix, var.cluster_use_name_prefix)
  allocated_storage                           = try(each.value.allocated_storage, var.allocated_storage)
  allow_major_version_upgrade                 = try(each.value.allow_major_version_upgrade, var.allow_major_version_upgrade)
  apply_immediately                           = try(each.value.apply_immediately, var.apply_immediately)
  availability_zones                          = try(each.value.availability_zones, var.availability_zones)
  backup_retention_period                     = try(each.value.backup_retention_period, var.backup_retention_period)
  backtrack_window                            = try(each.value.backtrack_window, var.backtrack_window)
  cluster_members                             = try(each.value.cluster_members, var.cluster_members)
  copy_tags_to_snapshot                       = try(each.value.copy_tags_to_snapshot, var.copy_tags_to_snapshot)
  database_name                               = try(each.value.database_name, var.database_name)
  db_cluster_instance_class                   = try(each.value.db_cluster_instance_class, var.db_cluster_instance_class)
  db_cluster_db_instance_parameter_group_name = try(each.value.db_cluster_db_instance_parameter_group_name, var.db_cluster_db_instance_parameter_group_name)
  deletion_protection                         = try(each.value.deletion_protection, var.deletion_protection)
  enable_global_write_forwarding              = try(each.value.enable_global_write_forwarding, var.enable_global_write_forwarding)
  enabled_cloudwatch_logs_exports             = try(each.value.enabled_cloudwatch_logs_exports, var.enabled_cloudwatch_logs_exports)
  enable_http_endpoint                        = try(each.value.enable_http_endpoint, var.enable_http_endpoint)
  engine                                      = try(each.value.engine, var.engine)
  engine_mode                                 = try(each.value.engine_mode, var.engine_mode)
  engine_version                              = try(each.value.engine_version, var.engine_version)
  final_snapshot_identifier                   = try(each.value.final_snapshot_identifier, var.final_snapshot_identifier)
  global_cluster_identifier                   = try(each.value.global_cluster_identifier, var.global_cluster_identifier)
  iam_database_authentication_enabled         = try(each.value.iam_database_authentication_enabled, var.iam_database_authentication_enabled)
  iops                                        = try(each.value.iops, var.iops)
  kms_key_id                                  = try(each.value.kms_key_id, var.kms_key_id)
  manage_master_user_password                 = try(each.value.manage_master_user_password, var.manage_master_user_password)
  master_user_secret_kms_key_id               = try(each.value.master_user_secret_kms_key_id, var.master_user_secret_kms_key_id)
  master_password                             = try(each.value.create_random_password, var.create_random_password) ? module.random_password[each.key].result : each.value.master_password
  master_username                             = try(each.value.master_username, var.master_username)
  network_type                                = try(each.value.network_type, var.network_type)
  port                                        = try(each.value.port, var.port)
  preferred_backup_window                     = try(each.value.preferred_backup_window, var.preferred_backup_window)
  preferred_maintenance_window                = try(each.value.preferred_maintenance_window, var.preferred_maintenance_window)
  replication_source_identifier               = try(each.value.replication_source_identifier, var.replication_source_identifier)
  restore_to_point_in_time                    = try(each.value.restore_to_point_in_time, var.restore_to_point_in_time)
  s3_import                                   = try(each.value.s3_import, var.s3_import)
  scaling_configuration                       = try(each.value.scaling_configuration, var.scaling_configuration)
  serverlessv2_scaling_configuration          = try(each.value.serverlessv2_scaling_configuration, var.serverlessv2_scaling_configuration)
  skip_final_snapshot                         = try(each.value.skip_final_snapshot, var.skip_final_snapshot)
  snapshot_identifier                         = try(each.value.snapshot_identifier, var.snapshot_identifier)
  source_region                               = try(each.value.source_region, var.source_region)
  storage_encrypted                           = try(each.value.storage_encrypted, var.storage_encrypted)
  storage_type                                = try(each.value.storage_type, var.storage_type)
  cluster_tags                                = try(each.value.cluster_tags, var.cluster_tags)
  vpc_security_group_ids                      = try(each.value.vpc_security_group_ids, var.vpc_security_group_ids)
  cluster_timeouts                            = try(each.value.cluster_timeouts, var.cluster_timeouts)
  instances                                   = try(each.value.instances, var.instances)
  auto_minor_version_upgrade                  = try(each.value.auto_minor_version_upgrade, var.auto_minor_version_upgrade)
  ca_cert_identifier                          = try(each.value.ca_cert_identifier, var.ca_cert_identifier)
  db_parameter_group_name                     = try(each.value.db_parameter_group_name, var.db_parameter_group_name)
  instances_use_identifier_prefix             = try(each.value.instances_use_identifier_prefix, var.instances_use_identifier_prefix)
  instance_class                              = try(each.value.instance_class, var.instance_class)
  monitoring_interval                         = try(each.value.monitoring_interval, var.monitoring_interval)
  performance_insights_enabled                = try(each.value.performance_insights_enabled, var.performance_insights_enabled)
  performance_insights_kms_key_id             = try(each.value.performance_insights_kms_key_id, var.performance_insights_kms_key_id)
  performance_insights_retention_period       = try(each.value.performance_insights_retention_period, var.performance_insights_retention_period)
  publicly_accessible                         = try(each.value.publicly_accessible, var.publicly_accessible)
  instance_timeouts                           = try(each.value.instance_timeouts, var.instance_timeouts)
  endpoints                                   = try(each.value.endpoints, var.endpoints)
  iam_roles                                   = try(each.value.iam_roles, var.iam_roles)
  create_monitoring_role                      = try(each.value.create_monitoring_role, var.create_monitoring_role)
  monitoring_role_arn                         = try(each.value.monitoring_role_arn, var.monitoring_role_arn)
  iam_role_name                               = try(each.value.iam_role_name, var.iam_role_name)
  iam_role_use_name_prefix                    = try(each.value.iam_role_use_name_prefix, var.iam_role_use_name_prefix)
  iam_role_description                        = try(each.value.iam_role_description, var.iam_role_description)
  iam_role_path                               = try(each.value.iam_role_path, var.iam_role_path)
  iam_role_managed_policy_arns                = try(each.value.iam_role_managed_policy_arns, var.iam_role_managed_policy_arns)
  iam_role_permissions_boundary               = try(each.value.iam_role_permissions_boundary, var.iam_role_permissions_boundary)
  iam_role_force_detach_policies              = try(each.value.iam_role_force_detach_policies, var.iam_role_force_detach_policies)
  iam_role_max_session_duration               = try(each.value.iam_role_max_session_duration, var.iam_role_max_session_duration)
  autoscaling_enabled                         = try(each.value.autoscaling_enabled, var.autoscaling_enabled)
  autoscaling_max_capacity                    = try(each.value.autoscaling_max_capacity, var.autoscaling_max_capacity)
  autoscaling_min_capacity                    = try(each.value.autoscaling_min_capacity, var.autoscaling_min_capacity)
  autoscaling_policy_name                     = try(each.value.autoscaling_policy_name, var.autoscaling_policy_name)
  predefined_metric_type                      = try(each.value.predefined_metric_type, var.predefined_metric_type)
  autoscaling_scale_in_cooldown               = try(each.value.autoscaling_scale_in_cooldown, var.autoscaling_scale_in_cooldown)
  autoscaling_scale_out_cooldown              = try(each.value.autoscaling_scale_out_cooldown, var.autoscaling_scale_out_cooldown)
  autoscaling_target_cpu                      = try(each.value.autoscaling_target_cpu, var.autoscaling_target_cpu)
  autoscaling_target_connections              = try(each.value.autoscaling_target_connections, var.autoscaling_target_connections)
  create_security_group                       = try(each.value.create_security_group, var.create_security_group)
  security_group_name                         = try(each.value.security_group_name, var.security_group_name)
  security_group_use_name_prefix              = try(each.value.security_group_use_name_prefix, var.security_group_use_name_prefix)
  security_group_description                  = try(each.value.security_group_description, var.security_group_description)
  vpc_id                                      = module.vpc_details[each.key].vpc_id
  security_group_rules                        = try(each.value.security_group_rules, var.security_group_rules)
  security_group_tags                         = try(each.value.security_group_tags, var.security_group_tags)
  create_db_cluster_parameter_group           = try(each.value.create_db_cluster_parameter_group, var.create_db_cluster_parameter_group)
  db_cluster_parameter_group_name             = try(each.value.db_cluster_parameter_group_name, var.db_cluster_parameter_group_name)
  db_cluster_parameter_group_use_name_prefix  = try(each.value.db_cluster_parameter_group_use_name_prefix, var.db_cluster_parameter_group_use_name_prefix)
  db_cluster_parameter_group_description      = try(each.value.db_cluster_parameter_group_description, var.db_cluster_parameter_group_description)
  db_cluster_parameter_group_family           = try(each.value.db_cluster_parameter_group_family, var.db_cluster_parameter_group_family)
  db_cluster_parameter_group_parameters       = try(each.value.db_cluster_parameter_group_parameters, var.db_cluster_parameter_group_parameters)
  create_db_parameter_group                   = try(each.value.create_db_parameter_group, var.create_db_parameter_group)
  db_parameter_group_use_name_prefix          = try(each.value.db_parameter_group_use_name_prefix, var.db_parameter_group_use_name_prefix)
  db_parameter_group_description              = try(each.value.db_parameter_group_description, var.db_parameter_group_description)
  db_parameter_group_family                   = try(each.value.db_parameter_group_family, var.db_parameter_group_family)
  db_parameter_group_parameters               = try(each.value.db_parameter_group_parameters, var.db_parameter_group_parameters)
  create_cloudwatch_log_group                 = try(each.value.create_cloudwatch_log_group, var.create_cloudwatch_log_group)
  cloudwatch_log_group_retention_in_days      = try(each.value.cloudwatch_log_group_retention_in_days, var.cloudwatch_log_group_retention_in_days)
  cloudwatch_log_group_kms_key_id             = try(each.value.cloudwatch_log_group_kms_key_id, var.cloudwatch_log_group_kms_key_id)
}

module "random_password" {
  source                 = "./random_password"
  for_each               = var.rds_aurora_config
  create_random_password = try(each.value.create_random_password, var.create_random_password)
  password_length        = try(each.value.random_password_length, var.random_password_length)
}
